---
title: display
slug: Web/CSS/display
tags:
  - CSS
  - CSS Display
  - CSS Property
  - Reference
  - display
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p class="summary">The <strong><code>display</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets whether an element is treated as a <a href="/en-US/docs/Web/CSS/CSS_Flow_Layout" rel="nofollow">block or inline element</a> and the layout used for its children, such as <a href="/en-US/docs/Web/CSS/CSS_Flow_Layout">flow layout</a>, <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout" rel="nofollow">grid</a> or <a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout" rel="nofollow">flex</a>.</p>

<p>Formally, the <strong><code>display</code></strong> property sets an element's inner and outer <em>display types</em>. The outer type sets an element's participation in <a href="/en-US/docs/Web/CSS/CSS_Flow_Layout">flow layout</a>; the inner type sets the layout of children. Some values of <code>display</code> are fully defined in their own individual specifications; for example the detail of what happens when <code>display: flex</code> is declared is defined in the CSS Flexible Box Model specification. See <a href="#Specifications">the table at the end of this document</a> for all of the individual specifications.</p>

<h2 id="Syntax">Syntax</h2>

<p>The CSS <code>display</code> property is specified using keyword values. Keyword values are grouped into six value categories:</p>

<pre class="brush: css notranslate">.container {
  display:  [ &lt;display-outside&gt; | &lt;display-inside&gt; ] | &lt;display-listitem&gt; | &lt;display-internal&gt; | &lt;display-box&gt; | &lt;display-legacy&gt; ;
}
</pre>

<h3 id="Outside">Outside</h3>

<dl>
 <dt>{{CSSxRef("&lt;display-outside&gt;")}}</dt>
 <dd>These keywords specify the element’s outer display type, which is essentially its role in flow layout.</dd>
</dl>

<p>{{page("/en-US/docs/Web/CSS/display-outside", "Syntax")}}</p>

<h3 id="Inside">Inside</h3>

<dl>
 <dt>{{CSSxRef("&lt;display-inside&gt;")}}</dt>
 <dd>These keywords specify the element’s inner display type, which defines the type of formatting context that its contents are laid out in (assuming it is a non-replaced element).</dd>
</dl>

<p>{{page("/en-US/docs/Web/CSS/display-inside", "Syntax")}}</p>

<h3 id="List_Item">List Item</h3>

<dl>
 <dt>{{CSSxRef("&lt;display-listitem&gt;")}}</dt>
 <dd>The element generates a block box for the content and a separate list-item inline box.</dd>
</dl>

<p>{{page("/en-US/docs/Web/CSS/display-listitem", "Syntax")}}</p>

<h3 id="Internal">Internal</h3>

<dl>
 <dt>{{CSSxRef("&lt;display-internal&gt;")}}</dt>
 <dd>Some layout models such as <code><span class="css">table</span></code> and <code>ruby</code> have a complex internal structure, with several different roles that their children and descendants can fill. This section defines those "internal" display values, which only have meaning within that particular layout mode.</dd>
</dl>

<p>{{page("/en-US/docs/Web/CSS/display-internal", "Syntax")}}</p>

<h3 id="Box">Box</h3>

<dl>
 <dt>{{CSSxRef("&lt;display-box&gt;")}}</dt>
 <dd>These values define whether an element generates display boxes at all.</dd>
</dl>

<p>{{page("/en-US/docs/Web/CSS/display-box", "Syntax")}}</p>

<h3 id="Legacy">Legacy</h3>

<dl>
 <dt>{{CSSxRef("&lt;display-legacy&gt;")}}</dt>
 <dd>CSS 2 used a single-keyword syntax for the <code>display</code> property, requiring separate keywords for block-level and inline-level variants of the same layout mode.</dd>
</dl>

<p>{{page("/en-US/docs/Web/CSS/display-legacy", "Syntax")}}</p>

<h3 id="Which_syntax_should_you_use_now">Which syntax should you use now?</h3>

<p>The Level 3 specification details two values for the <code>display</code> property — enabling the specification of the outer and inner display type explicitly — but this is not yet well-supported by browsers.</p>

<p>The <code>&lt;display-legacy&gt;</code> methods allow the same results with single keyword values, and should be favoured by developers until the two keyword values are better supported. For example, using two values you might specify an inline flex container as follows:</p>

<pre class="brush: css notranslate">.container {
  display: inline flex;
}</pre>

<p>This can currently be specified using a single value.</p>

<pre class="brush: css notranslate">.container {
  display: inline-flex;
}</pre>

<p>For more information on these changes to the specification, see the article <a href="/en-US/docs/Web/CSS/display/two-value_syntax_of_display">Adapting to the new two-value syntax of display</a>.</p>

<h3 id="Global">Global</h3>

<pre class="brush:css notranslate">/* Global values */
display: inherit;
display: initial;
display: unset;
</pre>

<h2 id="Description">Description</h2>

<p>The individual pages for the different types of value that <code>display</code> can have set on it feature multiple examples of those values in action — see the {{anch("Syntax")}} section. In addition, see the following material, which covers the various values of display in depth.</p>

<ul>
 <li><a href="/en-US/docs/Web/CSS/display/two-value_syntax_of_display">Adapting to the new two-value syntax of display</a></li>
</ul>

<h3 id="CSS_Flow_Layout_display_block_display_inline">CSS Flow Layout (display: block, display: inline)</h3>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/Block_and_Inline_Layout_in_Normal_Flow">Block and Inline Layout in Normal Flow</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/Flow_Layout_and_Overflow">Flow Layout and Overflow</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/Flow_Layout_and_Writing_Modes">Flow Layout and Writing Modes</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/Formatting_Contexts_Explained">Formatting Contexts Explained</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/In_Flow_and_Out_of_Flow">In Flow and Out of Flow</a></li>
</ul>

<h3 id="display_flex">display: flex</h3>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Basic_Concepts_of_Flexbox">Basic concepts of flexbox</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Aligning_Items_in_a_Flex_Container">Aligning Items in a Flex Container</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Controlling_Ratios_of_Flex_Items_Along_the_Main_Ax">Controlling Ratios of Flex Items Along the Main Axis</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Mixins">Cross-browser Flexbox mixins</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Mastering_Wrapping_of_Flex_Items">Mastering Wrapping of Flex Items</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Ordering_Flex_Items">Ordering Flex Items</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Relationship_of_Flexbox_to_Other_Layout_Methods">Relationship of flexbox to other layout methods</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Backwards_Compatibility_of_Flexbox">Backwards Compatibility of Flexbox</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Typical_Use_Cases_of_Flexbox">Typical use cases of Flexbox</a></li>
</ul>

<h3 id="display_grid">display: grid</h3>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Basic_Concepts_of_Grid_Layout">Basic Concepts of Grid Layout</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Relationship_of_Grid_Layout">Relationship to other layout methods</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Line-based_Placement_with_CSS_Grid">Line-based placement</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Grid_Template_Areas">Grid template areas</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Layout_using_Named_Grid_Lines">Layout using named grid lines</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Auto-placement_in_CSS_Grid_Layout">Auto-placement in grid layout</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Box_Alignment_in_CSS_Grid_Layout">Box alignment in grid layout</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid,_Logical_Values_and_Writing_Modes">Grids, logical values and writing modes</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_Layout_and_Accessibility">CSS Grid Layout and Accessibility</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_and_Progressive_Enhancement">CSS Grid Layout and Progressive Enhancement</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Realizing_common_layouts_using_CSS_Grid_Layout">Realizing common layouts using grids</a></li>
</ul>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<h3 id="display_none">display: none</h3>

<p>Using a <code>display</code> value of <code>none</code> on an element will remove it from the <a href="/en-US/docs/Learn/Accessibility/What_is_accessibility#Accessibility_APIs">accessibility tree</a>. This will cause the element and all its descendant elements to no longer be announced by screen reading technology.</p>

<p>If you want to visually hide the element, a more accessible alternative is to use <a class="external" href="https://gomakethings.com/hidden-content-for-better-a11y/#hiding-the-link">a combination of properties</a> to remove it visually from the screen but keep it parseable by assistive technology such as screen readers.</p>

<h3 id="display_contents">display: contents</h3>

<p>Current implementations in most browsers will remove from the <a href="/en-US/docs/Learn/Accessibility/What_is_accessibility#Accessibility_APIs">accessibility tree</a> any element with a <code>display</code> value of <code>contents</code> (but descendants will remain). This will cause the element itself to no longer be announced by screen reading technology. This is incorrect behavior according to the <a href="https://drafts.csswg.org/css-display/#valdef-display-contents">CSS specification</a>.</p>

<ul>
 <li><a class="external" href="https://hiddedevries.nl/en/blog/2018-04-21-more-accessible-markup-with-display-contents">More accessible markup with display: contents | Hidde de Vries</a></li>
 <li><a class="external" href="http://adrianroselli.com/2018/05/display-contents-is-not-a-css-reset.html">Display: Contents Is Not a CSS Reset | Adrian Roselli</a></li>
</ul>

<h3 id="Tables">Tables</h3>

<p>Changing the <code>display</code> value of a {{HTMLElement("table")}} element to <code>block</code>, <code>grid</code>, or <code>flex</code> will alter its representation in the <a href="/en-US/docs/Learn/Accessibility/What_is_accessibility#Accessibility_APIs">accessibility tree</a>. This will cause the table to no longer be announced properly by screen reading technology.</p>

<ul>
 <li><a class="external" href="https://developer.paciellogroup.com/blog/2018/03/short-note-on-what-css-display-properties-do-to-table-semantics/">Short note on what CSS display properties do to table semantics — The Paciello Group</a></li>
 <li><a class="external" href="https://gomakethings.com/hidden-content-for-better-a11y/">Hidden content for better a11y | Go Make Things</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable#Guideline_1.3_%E2%80%94_Create_content_that_can_be_presented_in_different_ways">MDN Understanding WCAG, Guideline 1.3 explanations</a></li>
 <li><a class="external" href="https://www.w3.org/TR/UNDERSTANDING-WCAG20/content-structure-separation-programmatic.html">Understanding Success Criterion 1.3.1 | W3C Understanding WCAG 2.0</a></li>
</ul>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="display_value_comparison">display value comparison</h3>

<p>In this example we have two block-level container elements, each one with three inline children. Below that, we have a select menu that allows you to apply different <code>display</code> values to the containers, allowing you to compare and contrast how the different values affect the element's layout, and that of their children.</p>

<p>We've included {{cssxref("padding")}} and {{cssxref("background-color")}} on the containers and their children, so that it is easier to see the effect the display values are having.</p>

<div class="notecard note">
<p><strong>Note</strong>: We've not included any of the modern two-value syntax, as support for that is still fairly limited.</p>
</div>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;article class="container"&gt;
  &lt;span&gt;First&lt;/span&gt;
  &lt;span&gt;Second&lt;/span&gt;
  &lt;span&gt;Third&lt;/span&gt;
&lt;/article&gt;

&lt;article class="container"&gt;
  &lt;span&gt;First&lt;/span&gt;
  &lt;span&gt;Second&lt;/span&gt;
  &lt;span&gt;Third&lt;/span&gt;
&lt;/article&gt;

&lt;div&gt;
  &lt;label for="display"&gt;Choose a display value:&lt;/label&gt;
  &lt;select id="display"&gt;
    &lt;option selected&gt;block&lt;/option&gt;
    &lt;option&gt;inline&lt;/option&gt;
    &lt;option&gt;inline-block&lt;/option&gt;
    &lt;option&gt;none&lt;/option&gt;
    &lt;option&gt;flex&lt;/option&gt;
    &lt;option&gt;inline-flex&lt;/option&gt;
    &lt;option&gt;grid&lt;/option&gt;
    &lt;option&gt;inline-grid&lt;/option&gt;
    &lt;option&gt;table&lt;/option&gt;
    &lt;option&gt;list-item&lt;/option&gt;
  &lt;/select&gt;
&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">html {
  font-family: helvetica, arial, sans-serif;
  letter-spacing: 1px;
  padding-top: 10px;
}

article {
  background-color: red;
}

article span {
  background-color: black;
  color: white;
  margin: 1px;
}

article, span {
  padding: 10px;
  border-radius: 7px;
}

article, div {
  margin: 20px;
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">const articles = document.querySelectorAll('.container');
const select = document.querySelector('select');

function updateDisplay() {
  articles.forEach((article) =&gt; {
    article.style.display = select.value;
  });
}

select.addEventListener('change', updateDisplay);

updateDisplay();</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('display_value_comparison','100%', 440)}}</p>

<div class="notecard note">
<p><strong>Note</strong>: You can find more examples in the pages for each separate display data type, linked above.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Display', '#the-display-properties', 'display')}}</td>
   <td>{{Spec2('CSS3 Display')}}</td>
   <td>Added <code>run-in</code>, <code>flow</code>, <code>flow-root</code>, <code>contents</code>, and multi-keyword values.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Ruby', '#ruby-display', 'display')}}</td>
   <td>{{Spec2('CSS3 Ruby')}}</td>
   <td>Added <code>ruby</code>, <code>ruby-base</code>, <code>ruby-text</code>, <code>ruby-base-container</code>, and <code>ruby-text-container</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Grid', '#grid-containers', 'display')}}</td>
   <td>{{Spec2('CSS3 Grid')}}</td>
   <td>Added the grid box model values.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Flexbox', '#flex-containers', 'display')}}</td>
   <td>{{Spec2('CSS3 Flexbox')}}</td>
   <td>Added the flexible box model values.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'visuren.html#display-prop', 'display')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Added the table model values and <code>inline-block<em>.</em></code></td>
  </tr>
  <tr>
   <td>{{SpecName('CSS1', '#display', 'display')}}</td>
   <td>{{Spec2('CSS1')}}</td>
   <td>Initial definition. Basic values: <code>none</code>, <code>block</code>, <code>inline</code>, and <code>list-item</code>.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("css.properties.display", 10)}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/Block_and_Inline_Layout_in_Normal_Flow">Block and inline layout in normal flow</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/Intro_to_formatting_contexts">Introduction to formatting contexts</a></li>
 <li>{{CSSxRef("visibility")}}, {{CSSxRef("float")}}, {{CSSxRef("position")}}</li>
 <li>{{CSSxRef("grid")}}, {{CSSxRef("flex")}}</li>
</ul>
